# DIAGNOSTICS & DEBUGGING OUTPUT # UPDATED: v2016.10.01 v2
sys.Log("+ - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - +")
sys.Log("+     NEW OUTBOUND CALL INITIATED!   OUTBOUND CALL LEG INFORMATION!     +")
sys.Log("+ - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - +")
sys.Log("o: req.URI: #{req.URI} // req.URI.Host: #{req.URI.Host} // req.URI.Host.to_s: #{req.URI.Host.to_s}")
sys.Log("o: req.URI.User: #{req.URI.User} // req.URI.User.to_s: #{req.URI.User.to_s{}} // req.Header: #{req.Header}")
sys.Log("o: req.URI.ToString: #{req.URI.ToString{}}")
sys.Log("o: req.Header.From: #{req.Header.From}")
sys.Log("o: req.Header.From.FromURI: #{req.Header.From.FromURI}")
sys.Log("o: req.Header.From.FromURI.User: #{req.Header.From.FromURI.User} // req.Header.from.FromURI.Host: #{req.Header.from.FromURI.Host}")
sys.Log("o: req.Header.from.FromURI.User.to_s: #{req.Header.from.FromURI.User.to_s} /// req.Header.From.FromName: #{req.Header.From.FromName}")
sys.Log("o: req.Header.From.ToString: #{req.Header.From.ToString()}")
sys.Log("o: req.Header.To: #{req.Header.To}")
sys.Log("o: req.Header.To.to_s: #{req.Header.To.to_s}")
sys.Log("o: req.Header.To.ToURI: #{req.Header.To.ToURI} // req.Header.To.ToName: #{req.Header.To.ToName}")
sys.Log("o: req.Header.Contact[0]: #{req.Header.Contact[0]}")
sys.Log("o: req.Header.Contact[0].ContactURI: #{req.Header.Contact[0].ContactURI}")
sys.Log("o: req.Header.Contact[0].ContactName: #{req.Header.Contact[0].ContactName}")
sys.Log("o: req.Header.CSeq: #{req.Header.CSeq} // req.Header.CallId: #{req.Header.CallId}")
sys.log("+ - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - + - - - +")
sys.Log("")

# START CALL LOGIC RULES
case req.URI.User

 # ------------------------------------------------------------------------------------
 # SPEED DIAL # [INTERNAL VIRTUAL EXTENSIONS]
 # ------------------------------------------------------------------------------------
 # >> VSPs: SIPSorcery, and VSPs supporting SIP URI.
 # NOTE: Recommend 3 to 5 digit extensions.  Replace "__Name__" fields with the memorable name you wish to assign people; plus "___@" with destinations. E.g. 202 and Alex and 12345@xxx. So you can then use a SoftPhone and enter just "alex" to dial his/her number(s).
    when /^200/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com",25) # 
        sys.Dial("____@sipsorcery.com") # Alternate 'number' if first fails/no answer.
    when /^201/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com") # 
    when /^202/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com") # 

    when /^211/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com") # 
    when /^212/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com",25) # 
        sys.Dial("____@sipsorcery.com") # Alternate 'number' if first fails/no answer.

    when /^221/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com") # 
    when /^222/, "__Name__" then sys.Log("==== __Name__ Speed Dial =====")
        sys.Dial("____@sipsorcery.com") # 


 # ------------------------------------------------------------------------------------
 # SPEED DIAL # [EXTERNAL SIP URI CALLS]
 # ------------------------------------------------------------------------------------
  # >> VSPs: SIPSorcery, PTL_x MNF_x TLC_x, and VSPs supporting SIP URI.
  # [FAMILY & FRIENDS]
    when /^____/ then sys.Dial("____@____")
    when "____" then sys.Dial("____@____")
  # [WORK & CLIENTS]
    when /^____/ then sys.Dial("____@____")
    when "____" then sys.Dial("____@____")
  # [OTHER RULES]
    when /^____/ then sys.Dial("____@____")
    when "____" then sys.Dial("____@____")


 # ------------------------------------------------------------------------------------
 # VSP ACCOUNT OVERRIDE PREFIXES # [BYPASS DEFAULT DIALING RULES]
 # ------------------------------------------------------------------------------------
  # >> VSPs: SIPSorcery, SIP Broker, PTL_x MNF_x TLC_x, and VSPs supporting SIP URI.
  # NOTE: I recommend "/^xx\*/" (xx*) over "/^\*xx/" (*xx) as supports more entries.
  # NUMBER + ASTERISK OVERRIDES [Preferred to Avoid Logic Confusion or Hardware Conflicts]
    when /^1\*/ then sys.Dial("${EXTEN:2}@____") # MNF Untimed + DID xxxx xxxx
     when /^2\*/ then sys.Dial("${EXTEN:2}@____") # MNF Trunk
     when /^3\*/ then sys.Dial("${EXTEN:2}@____") # MNF Overflow

    when /^4\*/ then sys.Dial("${EXTEN:2}@____") # PTL Untimed
     when /^5\*/ then sys.Dial("${EXTEN:2}@____") # PTL Timed

    # when /^6\*/ then sys.Dial("${EXTEN:2}@____") # Offline
    when /^7\*/ then sys.Dial("${EXTEN:2}@____") # TLC Untimed Trunk
     when /^8\*/ then sys.Dial("${EXTEN:2}@____") # TLC Timed Trunk

    when /^9\*/ then sys.Dial("${EXTEN:1}@sipbroker.com[rm=a]")   # 9*234.. to *234..@sipbroker.com")
      when /^\*9/ then sys.Dial("${EXTEN:1}@sipbroker.com[rm=a]") # 9*234.. to *234..@sipbroker.com")
    when /^0\*/ then sys.Dial("${EXTEN:2}@local")   # 0*blah to blah@sipsorcery.com")
      when /^\*0/ then sys.Dial("${EXTEN:2}@local") # 0*blah to blah@sipsorcery.com")

    # when /^10\*/ then sys.Dial("${EXTEN:3}@____") # Offline
    # when /^11\*/ then sys.Dial("${EXTEN:3}@____") # Offline

    # when /^__\*/ then sys.Dial("${EXTEN:3}@____") # 


 # ---------------------------------------------------------------------------------------------
 # VSP & PUBLIC DIAGNOSTIC NUMBERS | [MUSIC, ECHO TEST, CLID, DTMF, AUDIO CHANNEL & CONNECTIVITY]
 # ---------------------------------------------------------------------------------------------
 # >> SIPSorcery, SIP Broker, Any VSP SIP URI's.
    when /^311/ then sys.Dial("music@iptel.org")          # Normal - Media/Music
    when /^312/ then sys.Dial("early_music@iptel.org")    # Early Media - Media/Music
    when /^313/ then sys.Dial("echo@iptel.org")           # Echo Test
    when /^314/ then sys.Dial("3246@iptel.org")           # Echo Test
    when /^315/ then sys.Dial("2233435945@sip2sip.info")  # LENNY - 2 Way Audio Test ++ Annoy Marketing Calls!!!!
    when /^316/ then sys.Dial("wbdemo@conf.zipdx.com")    # Wide Band - Media/Music
    when /^317/ then sys.Dial("6414539840@podlinez.net")  # Parliment Question Time
    # when /^318/ then sys.Dial("775@sip.pennytel.com")   # Narrow Band - Media/Music
 
    when /^317/ then sys.Dial("904@mouselike.org")        # 1. Echo, 2. VM, 3 Music, 4. Audio quality sweep test, 5. monitor line test.
    when /^318/ then sys.Dial("4151595@services.sip.is")  # 1. Echo, 2. Hold, 3. Rec + Listen, 4. Read CID. # NOTE: 340ms Latency
    when /^320/ then sys.Dial("201@ideasip.com")          # Welcome Message
    when /^321/ then sys.Dial("301@ideasip.com")          # Echo Test
    when /^322/ then sys.Dial("411@ideasip.com")          # Dial Free Call '411' Numbers & use '*' to connect, IVR AUDIO
    when /^323/ then sys.Dial("8355@ideasip.com")         # TellMe Information Service
    when /^324/ then sys.Dial("8463@ideasip.com")         # Time Service (Eastern Time, US)

    when /^331/ then sys.Dial("0871271201@____")          # Two-way Audio Echo Test.
    when /^332/ then sys.Dial("0871271202@____")          # Radio Paradise Music.
    when /^333/ then sys.Dial("0871271203@____")          # Announce CLI / CLID / CID.
    when /^334/ then sys.Dial("0871271204@____")          # Speaking Day/Date/Time.
    when /^335/ then sys.Dial("0871271205@____")          # Test DTMF Key Tones.
=begin
        BROKEN - FAULTY - OFFLINE?
         9901@qxip.net / 9902@qxip.net / 9999@qxip.net
         pirateradio@qxip.net / 13108254321@ucla.edu
         telephreak@voip.telephreak.org / info@intertex.se
         17622600@projectmf.homelinux.com / lenny@sip.itslenny.com
=end
    when /^341/ then sys.Dial("hangup$PICKED_OFF@conference.freeswitch.org") # hangup$HANGUP_CAUSE@conference.freeswitch.org
     # when /^3__/ then sys.Dial("hangup$____@conference.freeswitch.org") #  # 18002464411@tollfree.alcazarnetworks.com >>> https://wiki.freeswitch.org/wiki/Hangup_Causes OR http://www.voip-info.org/wiki/view/Asterisk+variable+hangupcause

    #when /^3__/ then sys.Dial("____")


 # ------------------------------------------------------------------------------------
 # REGULAR DIALING RULES | [AUSTRALIAN PATTERN EXAMPLES FOR DIALING STANDARD NUMBERS]
 # ------------------------------------------------------------------------------------
   # FYI: ${EXTEN:2} = Remove to RHS of 2nd Character. EXTEN:X:X (Position, Replace) Not Available! :(
    when /^000/, /^106/, /^112/ then sys.Dial("${EXTEN}@____") # 000S0| 112S0| 106S0 hearing impaired. NOTE: not all VSPs support emergency services!
                sys.Dial("${EXTEN}@____",20) # Backup if 1st fails.
                sys.Dial("${EXTEN}@____",20) # Backup if 2nd fails.
    when /^0011/ then sys.Dial("${EXTEN}@____") # 0011xxxxxxxx.S3| Create for specific country prefixes too!
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.

    # when "110", "114", "12[45]" "127x." "14x." "17x." then sys.Dial("${EXTEN}@____") # Patterns: 110 114 124/5 127. 14. 17. Not yet finished!
    when /^12[34]/, /^1234/, /^12455/, /^12456/, /^124937/ then rejectCall(603," ... NO PREMIUM  12xx ...") # 12[34]! 1234!|12455!|12456!|124937!|
    when /^122/, /^1223/, /^12245/ then sys.Dial("${EXTEN}@____") # 12x.S0|1223S0|12245S0|

    when /^10\d{5}/, /^99[0-9]99/ then sys.Dial("${EXTEN}@____") # 1012345, 99299 (Echo Test), 99599 (Balance)
    when /^211/, "TLC211", /^1031000/ then sys.Dial("____@____") # 
    when /^212/, "TLC212", /^1041000/ then sys.Dial("____@____") # 
    when /^213/, "TLC213", /^1051000/ then sys.Dial("____@____") # 

    # *** YOUR LOCAL CALLS - CHOOSE YOUR STATE ***
    # NSW 02, VIC/TAS 03 = [3-9]xxxxxxx or /^[3-9]\d{7}/
    # QLD 07 = [2-57]xxxxxxx or /^[2-57]\d{7}/
    # N.T. 08 = [258]xxxxxxx or /^[258]\d{7}/
    # S.A. 08 = [2578]xxxxxxx or /^[2578]\d{7}/
    # W.A. 08 = [2589]xxxxxxx or /^[2589]\d{7}/
    when /^[3-9]\d{7}/ then sys.Dial("${EXTEN}@____") # NSW/VIC/TAS: [3-9] or [346789]xxxxxxxS0|, 
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.

    when /^0[2378][2-9]\d{7}/, /^61[2378][2-9]\d{7}/, /^001161[2378][2-9]\d{7}/ then sys.Dial("${EXTEN}@____") # 0[2378][2-9]xxxxxxxS0! or 0[][]xxxxxxxS0! + 0[][]xxxxxxxS0! + 0[][]xxxxxxxS0! + 0[][]xxxxxxxS0! + ...
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.
    when /^0[1569]\d{8}/, /^61[1569]\d{8}/, /^001161[1569]\d{8}/ then sys.Dial("${EXTEN}@____") # 0[1569]xxxxxxxxS0| 0198, 0550, etc.
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.
    when /^04\d{8}/, /^614\d{8}/, /^0011614\d{8}/ then sys.Dial("${EXTEN}@____") # 0[4]xxxxxxxxS0|
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.

    when /^1[38]0[0-2]\d{6}/, /^611[38]0[0-2]\d{6}/, /^1[38]z\d{3}/, /^611[38]z\d{3}/, /^0011611[38][1-9]\d{3}/ then sys.Dial("${EXTEN}@____") # 1[38]00xxxxxxS0|1[38][1-9]xxxS0|
                sys.Dial("${EXTEN}@____",25) # Backup if 1st fails.
    when /^1[9]0[0-26]/, /^611[9]0[0-26]/, /^0011611[9]0[0-26]/ then sys.Respond(403, "NO PREMIUM 1900!!!") # 1[9]0[0126]!
      #? then rejectCall(603,"...")

    when /^1[258]1/, "09xxxxxx." then sys.Dial("${EXTEN}@____") # 1[258]1S0|09xxxxxxS0| #### UPDATED to "/^09\d{6}/ (MNF) /^09\d{12}/ (PTL) OR "09xxxxxx." for 8 and 14 digit MNF numbers! ####
    # when /^77[1578]/, /^888\d{7}/ then sys.Dial("${EXTEN}@VSP_4") # 77[1578]S0| 888xxxxxxxS0| #### UPDATED: PTL closed and sold out to MNF.


else
    sys.log("# - - - # - - - # - - - # - - - # - - - # - - - # - - - # - - - #")
    sys.log("... No Rule Match! .. .. No Rule Match! .. .. No Rule Match! ...")
    sys.log("Retrying EXTEN clean-up and without rules...")
    num = req.URI.User.to_s           # Return Dialled Number >> +61 (0)2 9988-1122 <<
    # num = num.downcase.slice(/[^:]+/) # Convert to Lowercase and Slice before ':'.
    num = num.gsub(/[^0-9*#]/,'')     # Strip ALL Text/Symbols (Except: 0-9, # (hash/pound), * (asterisk))
    sys.log("# - - - # - - - # - - - # - - - # - - - # - - - # - - - # - - - #")
    sys.Log("PRIMARY VSP [Cheapest VSP by Default]")
    sys.Dial("#{num}@____", 20)

    sys.Log("SECONDARY VSP [Alternate VSP, 2nd cheapest on average]")
    sys.Dial("#{num}@____", 20)

    sys.Log("TERTIARY VSP [Final Attempt VSP, most expensive]")
    sys.Dial("#{num}@____", 20)
    sys.log("# - - - # - - - # - - - # - - - # - - - # - - - # - - - # - - - #")

  # TO-DO: IF FAILS, SYS.EMAIL: SEND EMAIL NOTIFICATION WITH DEBUG INFO + ERROR + CALL DETAILS + STATS...
  # TO-DO: CREATE A CALL FORWARD SYSTEM THAT IS TURNED ON/OFF BY TIME OF DAY. USE DATABASE STORAGE...

    sys.Respond(404, "#--- Oops! No Destination Found, Destination Timed-Out, or No Dial Plan Matched URI/EXTEN: #{req.Header.To} / #{req.URI.User.to_s}! ---#")
end